Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## avrora.core.isdl.ast
Class MapBitAssignStmt

    java.lang.Object
      avrora.core.isdl.ast.Stmt
          avrora.core.isdl.ast.AssignStmt
              avrora.core.isdl.ast.MapBitAssignStmt

public class MapBitAssignStmt
extends AssignStmt

The `MapBitAssignStmt` represents an assignment to a single bit within an element within a map.

Field Summary
`Expr` | `bit` The `bit` field stores a reference to the expression which is evaluated to yield the bit index into the element of the map.
`Expr` | `index` The `index` field stores a references to the expression which is evaluated to yield the index into the map.
`Token` | `mapname` The `mapname` field stores a reference to the name of the map whose element is being assigned to.

Fields inherited from class avrora.core.isdl.ast.AssignStmt
`expr`

Constructor Summary
`MapBitAssignStmt(Token m, Expr i, Expr b, Expr e)` The constructor for the `MapAssignStmt` class initializes the public final fields in this class that refer to the elements of the assignment.

Method Summary
`Stmt` | `accept(StmtRebuilder r)` The `accept()` method implements one half of the visitor pattern for visiting the abstract syntax trees representing the code of a particular instruction or subroutine.
`void` | `accept(StmtVisitor v)` The `accept()` method implements one half of the visitor pattern for visiting the abstract syntax trees representing the code of a particular instruction or subroutine.
`java.lang.String` | `toString()` The `toString()` method recursively converts this statement to a string.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### mapname

    public final Token mapname

  The `mapname` field stores a reference to the name of the map whose element is being assigned to.

### index

    public final Expr index

  The `index` field stores a references to the expression which is evaluated to yield the index into the map.

### bit

    public final Expr bit

  The `bit` field stores a reference to the expression which is evaluated to yield the bit index into the element of the map.

Constructor Detail

### MapBitAssignStmt

    public MapBitAssignStmt(Token m,
                            Expr i,
                            Expr b,
                            Expr e)

  The constructor for the `MapAssignStmt` class initializes the public final fields in this class that refer to the elements of the assignment.

Parameters:
  `m` - the string name of the map as a token
  `i` - the expression representing the index into the map
  `b` - the expression representing the bit index into the element
  `e` - the expression representing the right hand side of the assignment

Method Detail

### accept

    public void accept(StmtVisitor v)

  The `accept()` method implements one half of the visitor pattern for visiting the abstract syntax trees representing the code of a particular instruction or subroutine.

  Specified by:
    `accept` in class `Stmt`
  Parameters:
    `v` - the visitor to accept

### toString

    public java.lang.String toString()

  The `toString()` method recursively converts this statement to a string.

  Returns:
    a string representation of this statement

### accept

    public Stmt accept(StmtRebuilder r)

  The `accept()` method implements one half of the visitor pattern for visiting the abstract syntax trees representing the code of a particular instruction or subroutine. The `StmtRebuilder` interface allows visitors to rearrange and rebuild the statements.

  Specified by:
    `accept` in class `Stmt`
  Parameters:
    `r` - the visitor to accept
  Returns:
    the result of calling the appropriate `visit()` of the rebuilder passed

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD